<?php

class importexport_data_b2c_goods extends importexport_data{// implements importexport_interface_data{

    public function __construct(){
        $this->model = $this->init('b2c','goods');
        $this->app = app::get('b2c');
    }

    var $ioSchema = array(
        'csv' => array(
            'bn:商品编号'=> 'bn',
            'ibn:规格货号' => array('bn','product'),
            'col:默认货品' => array('is_default','product'),
            'col:分类' => 'category/cat_id',
            'col:品牌' => 'brand/brand_id',
            'keywords:商品关键字' => 'keywords',
            'col:市场价' => array('price/mktprice/price','product'),
            'col:成本价' => array('price/cost/price','product'),
            'col:销售价' => array('price/price/price','product'),
            'col:缩略图' => 'thumbnail_pic',
            'col:图片文件' => '',
            'col:商品名称' => 'name',
            'col:上架' => 'status',
            'col:规格' => 'spec',
            'col:商品简介' => 'brief',
            'col:详细介绍' => 'description',
            'col:重量' => array('weight','product'),
            'col:单位' => 'unit',
            'col:库存' => array( 'store','product' )
        )
    );

    public function io_title( $filter,$ioType='csv' ){
        $title = array();
        switch( $ioType ){
            case 'csv':
            default:
                $oGtype = $this->app->model('goods_type');
                if( $this->csvExportGtype[$filter['type_id']] )
                    $gType = $this->csvExportGtype[$filter['type_id']];
                else
                    $gType = $oGtype->dump($filter['type_id'],'*');
                $this->oSchema['csv'][$filter['type_id']] = array(
                    '*:'.$gType['name']=>'type/name',
                    app::get('b2c')->_('bn:商品编号') => 'bn',
                    app::get('b2c')->_('ibn:规格货号') => array('bn','product'),
                    app::get('b2c')->_('col:默认货品') => array('is_default','product'),
                    app::get('b2c')->_('col:分类') => 'category/cat_name',
                    app::get('b2c')->_('col:品牌') => 'brand/brand_name',
                    app::get('b2c')->_('keywords:商品关键字') => 'keywords',
                    app::get('b2c')->_('col:市场价') => array('price/mktprice/price','product'),
                    app::get('b2c')->_('col:成本价') => array('price/cost/price','product'),
                    app::get('b2c')->_('col:销售价') => array('price/price/price','product'),
                    app::get('b2c')->_('col:缩略图') => 'thumbnail_pic',
                    app::get('b2c')->_('col:图片文件') => '',
                    app::get('b2c')->_('col:商品名称') => 'name',
                    app::get('b2c')->_('col:上架') => 'status',
                    app::get('b2c')->_('col:规格') => 'spec',
                    app::get('b2c')->_('col:库存') => 'store'
                );
                $oMlv = $this->app->model('member_lv');
                foreach( $oMlv->getList() as $mlv ){
                    $this->oSchema['csv'][$filter['type_id']]['price:'.$mlv['name']] = 'price/member_lv_price/'.$mlv['member_lv_id'].'/price';
                }
                $this->oSchema['csv'][$filter['type_id']] = array_merge(
                    $this->oSchema['csv'][$filter['type_id']],
                    array(
                        app::get('b2c')->_('col:商品简介') => 'brief',
                        app::get('b2c')->_('col:详细介绍') => 'description',
                        app::get('b2c')->_('col:重量') => 'weight',
                        app::get('b2c')->_('col:单位') => 'unit',
                    )
                );
                foreach( (array)$gType['props'] as $propsK => $props ){
                    $this->oSchema['csv'][$filter['type_id']]['props:'.$props['name']] = 'props/p_'.$propsK;
                }
                foreach( (array)$gType['params'] as $paramGroup => $paramItem ){
                    foreach( (array)$paramItem as $paramName => $paramValue ){
                        $this->oSchema['csv'][$filter['type_id']]['params:'.$paramGroup.'->'.$paramName] = 'params/'.$paramGroup.'/'.$paramName;
                    }
                }
                break;
        }
        $this->ioTitle['csv'][$filter['type_id']] = array_keys($this->oSchema['csv'][$filter['type_id']]);
        return $this->ioTitle['csv'][$filter['type_id']];
    }

    public function fgetlist(&$data,$filter,$offset){
        $subSdf = array(
            'keywords' => array('*'),
            'product'=>array(
                '*',array('price/member_lv_price'=>array('*'))
            ),
            'images'=>array('*',array(':image'=>array('*'))),
            ':brand'=>array('*')
        );
        $limit = 40;
        $is_none_data = false;
        if( $filter['_gType'] ){
            $title = array();
            if(!$data['title'])$data['title'] = array();
            $data['title'][''.$filter['_gType']] = '"'.implode('","', $this->io_title(array('type_id'=>$filter['_gType'])) ).'"';
            $is_none_data = true;
        }
        $oGtype = &$this->app->model('goods_type');
        if($is_none_data || !$goodsList = $this->model->getList('goods_id',$filter,$offset*$limit,$limit))return false;
        $data['content'] = array();
        foreach( $goodsList as $aFilter ){
            $aGoods = $this->model->dump( $aFilter['goods_id'],'*',$subSdf );
            if(empty($aGoods['thumbnail_pic']))  $aGoods['thumbnail_pic'] = $aGoods['image_default_id'];                        //为了防止少缩略图导后产生BUG

            if( !$aGoods )continue;
            if( !$this->csvExportGtype[$aGoods['type']['type_id']] ){
                $this->csvExportGtype[$aGoods['type']['type_id']] = $oGtype->dump($aGoods['type']['type_id'],'*');
                //$data['title'][$aGoods['type']['type_id']];
                $data['title'][$aGoods['type']['type_id']] = '"'.implode('","',$this->io_title($aGoods['type'])).'"';
            }
            if( $aGoods['keywords'] ){
                $goodsKeywords = array();
                foreach( $aGoods['keywords'] as $kwk => $kwv ){
                    $goodsKeywords[] = $kwv['keyword'];
                }
                $aGoods['keywords'] = implode('|',$goodsKeywords);
            }
            $csvData = $this->sdf2csv($aGoods);
            $data['content'][$aGoods['type']['type_id']] = array_merge((array)$data['content'][$aGoods['type']['type_id']],(array)$csvData);
        }
        return true;

    }

     function sdf2csv( $sdfdata ){
        $rs = array();
        $conTmp = array();
        $sdfdata['description'] = str_replace( '"','""', $sdfdata['description'] );
        foreach( $this->io_title( $sdfdata['type'] ) as $titleCol ){
            $conTmp[$titleCol] = '';
        }
        $gcontent = $conTmp;

        $sdfdata['type']['name'] = $this->csvExportGtype[$sdfdata['type']['type_id']]['name'];
        foreach( $this->oSchema['csv'][$sdfdata['type']['type_id']] as $title => $sdfpath ){
            if( !is_array($sdfpath) ){
                $tSdfCol = utils::apath($sdfdata,explode('/',$sdfpath));
                $gcontent[$title] = (is_array($tSdfCol)?$tSdfCol:$tSdfCol);
            }else{
                $gcontent[$title] = '';
            }
            if( substr($title,0,6) == 'props:' ){
                if( !$gcontent && $gcontent[$title]['value'] !== 0 ){
                    $gcontent[$title] = '';
                }else{
                    $k = explode('_',$sdfpath);
                    $k = $k[1];
                    if( $this->csvExportGtype[$sdfdata['type']['type_id']]['props'][$k]['options'] ){
                        $gcontent[$title] = $this->csvExportGtype[$sdfdata['type']['type_id']]['props'][$k]['options'][$gcontent[$title]['value']];
                    }else{
                        $gcontent[$title] = $gcontent[$title]['value'];
                    }
                }
            }
        }
       $cat = array();
        $oCat = &$this->app->model('goods_cat');
        $tcat = $oCat->dump($sdfdata['category']['cat_id'],'cat_path');
        $catPath = array();
        foreach( explode(',',$tcat['cat_path']) as $catv ){
            if( $catv )$catPath[] = $catv;
        }
        if( $sdfdata['category']['cat_id'] )
            $catPath[] = $sdfdata['category']['cat_id'];
        if( $catPath ){
           foreach( $oCat->getList('cat_name',array('cat_id'=>$catPath)) as $acat ){
               if( $acat ) $cat[] = $acat['cat_name'];
            }
            $gcontent[app::get('b2c')->_('col:分类')] = implode('->',$cat);
        }else{
            $gcontent[app::get('b2c')->_('col:分类')] = '';
        }
        $gcontent[app::get('b2c')->_('col:上架')] = $gcontent[app::get('b2c')->_('col:上架')] == 'true'?'Y':'N';
        if( $sdfdata['images'] ){
            $oImage = &app::get('image')->model('image');
            foreach( $sdfdata['images'] as $aImage ){
                $imageData = $oImage->dump($aImage['image_id'],'url');
                $gcontent[app::get('b2c')->_('col:图片文件')][] = $aImage['image_id'].'@'.$imageData['url'];
            }
            $gcontent[app::get('b2c')->_('col:图片文件')] = implode('#',$gcontent[app::get('b2c')->_('col:图片文件')]);
        }
        if( $sdfdata['udfimg'] == 'true' && $sdfdata['thumbnail_pic'] && substr($sdfdata['thumbnail_pic'],0,4 ) != 'http' ){
            $oImage = &app::get('image')->model('image');
            $imageData = $oImage->dump($sdfdata['thumbnail_pic'],'url');
            $gcontent[app::get('b2c')->_('col:缩略图')] = $sdfdata['thumbnail_pic'].'@'.$imageData['url'];

        }
        $this->oSchema['csv'][$sdfdata['type']['type_id']][app::get('b2c')->_('col:市场价')] = array('price/mktprice/price','product');
        $this->oSchema['csv'][$sdfdata['type']['type_id']][app::get('b2c')->_('col:成本价')] = array('price/cost/price','product');
        $this->oSchema['csv'][$sdfdata['type']['type_id']][app::get('b2c')->_('col:销售价')] = array('price/price/price','product');

        if( !$sdfdata['spec'] ){
            $product = current( (array)$sdfdata['product'] );
            foreach( $this->oSchema['csv'][$sdfdata['type']['type_id']] as $title => $sdfpath ){
                if( is_array($sdfpath) && $sdfpath[1] == 'product' ){
                    $tSdfCol = utils::apath($product,explode('/',$sdfpath[0]));
                    $gcontent[$title] = (is_array($tSdfCol))?$tSdfCol:$tSdfCol;
                }
            }
            $gcontent[app::get('b2c')->_('col:规格')] = '-';
            $rs[0] = '"'.implode('","',$gcontent).'"';
        }else{
            $spec = array();
            foreach( $sdfdata['spec'] as $aSpec ){
                $spec[] = $aSpec['spec_name'];
            }
            $gcontent[app::get('b2c')->_('col:规格')] = implode('|',$spec);

            $oSpec = &$this->app->model('spec_values');

            $rs[0] = '"'.implode('","',$gcontent).'"';
            foreach( $sdfdata['product'] as $row => $aSdfdata ){
                $content = $conTmp;
                foreach( $this->oSchema['csv'][$sdfdata['type']['type_id']] as $title => $sdfpath ){
                    $content[$title] = utils::apath($aSdfdata,explode('/',(!is_array($sdfpath)?$sdfpath:$sdfpath[0])));
                }
                $specValue = array();
                foreach( $oSpec->getList('spec_value',array('spec_value_id'=>$aSdfdata['spec_desc']['spec_value_id']) ) as $aSpecValue ){
                    $specValue[] = $aSpecValue['spec_value'];
                }
                $content[app::get('b2c')->_('col:规格')] = implode('|',$specValue);
                $content[app::get('b2c')->_('bn:商品编号')] = $gcontent[app::get('b2c')->_('bn:商品编号')];
                $content[app::get('b2c')->_('col:上架')] = $content[app::get('b2c')->_('col:上架')] == 'true'?'Y':'N';
                $content['*:'.$sdfdata['type']['name']] = $sdfdata['type']['name'];
                $rs[$row] = '"'.implode('","',$content).'"';
            }
        }
        return $rs;
    }

    public function prepared_import_obj($data,&$mark,$goodsTmpl,&$msg = ''){
        if( !$data['contents'] )return null;
        $mark = 'contents';
        $gData = &$data['contents'];
        $gTitle = $data['title'];
        $rs = array();
        //id
        if( $this->io->goodsBn && array_key_exists( $gData[0][$gTitle[app::get('b2c')->_('bn:商品编号')]] , $this->io->goodsBn ) ){
            $msg = array( 'error'=>app::get('b2c')->_('商品编号:').$gData[0][$gTitle[app::get('b2c')->_('bn:商品编号')]].app::get('b2c')->_(' 文件中有重复') );
            return false;
        }

        $goodsId = $this->model->dump(array('bn|tequal'=>$gData[0][$gTitle[app::get('b2c')->_('bn:商品编号')]]),'goods_id');
        if( $goodsId['goods_id'] ){
            $gData[0]['col:goods_id'] = $goodsId['goods_id'];
        }

        $gData[0][$gTitle[app::get('b2c')->_('col:上架')]] = (in_array( trim( $gData[0][$gTitle[app::get('b2c')->_('col:上架')]] ), array('Y','TRUE') )?'true':'false');

        foreach( $gTitle as $colk => $colv ){
            if( substr( $colk, 0,6 ) == 'props:' ){
                if( !$this->model->ioSchema['csv'][$colk] )
                    $msg['warning'][] = app::get('b2c')->_('属性：').ltrim($colk,'props:').app::get('b2c')->_('不存在');
                else{
                    if( $goodsTmpl['props_hash'][ltrim($colk,'props:')] && $gData[0][$gTitle[$colk]] && !array_key_exists( $gData[0][$gTitle[$colk]], $goodsTmpl['props_hash'][ltrim($colk,'props:')] ) )
                        $msg['warning'][] = app::get('b2c')->_('属性值：').$gData[0][$gTitle[$colk]].app::get('b2c')->_('不存在');
                    if( $goodsTmpl['props_hash'][ltrim($colk,'props:')] )
                        $gData[0][$gTitle[$colk]] = $goodsTmpl['props_hash'][ltrim($colk,'props:')][$gData[0][$gTitle[$colk]]];
                }
            }
            if( (substr( $colk,0,6 ) == 'price:' || in_array( $colk , array(app::get('b2c')->_('col:市场价'),app::get('b2c')->_('col:成本价'),app::get('b2c')->_('col:销售价')) ) ) && $gData[0][$gTitle[$colk]] !== 0 && !$gData[0][$gTitle[$colk]] ){
                unset($gData[0][$gTitle[$colk]]);
            }
        }

        //分类
        $catPath = array();
        $oCat = &$this->app->model('goods_cat');
        $catId = 0;
        foreach( explode( '->',$gData[0][$gTitle[app::get('b2c')->_('col:分类')]] ) as $catName ){
            $aCatId = $oCat->dump(array('cat_name'=>$catName,'parent_id'=>$catId),'cat_id');
            if( $aCatId )
                $catId = $aCatId['cat_id'];
            else
                $catId = 0;
        }
        $catId = $oCat->dump($catId,'cat_id');
        if( $gData[0][$gTitle[app::get('b2c')->_('col:分类')]] && !$catId['cat_id'] )
            $msg['warning'][] = app::get('b2c')->_('分类：').$gData[0][$gTitle[app::get('b2c')->_('col:分类')]].app::get('b2c')->_('不存在');
        $gData[0][$gTitle[app::get('b2c')->_('col:分类')]] = intval( $catId['cat_id']);

        //品牌
        $oBrand = &$this->app->model('brand');
        if( !$gData[0][$gTitle[app::get('b2c')->_('col:品牌')]] ){
            $brandId = array('brand_id'=>0);
        }else{
            $brandId = $oBrand->dump(array('brand_name'=>$gData[0][$gTitle[app::get('b2c')->_('col:品牌')]]),'brand_id');
            if( !$brandId['brand_id'] && $gData[0][$gTitle[app::get('b2c')->_('col:品牌')]] )
                $msg['warning'][] = app::get('b2c')->_('品牌：').$gData[0][$gTitle[app::get('b2c')->_('col:品牌')]].app::get('b2c')->_('不存在');
        }
        $gData[0][$gTitle[app::get('b2c')->_('col:品牌')]] = intval( $brandId['brand_id'] );

        //货品 处理return值
        $rs = $gData[0];
        $oPro = &$this->app->model('products');
        $spec = array();
        if( count( $gData ) == 1 ){
            unset($rs[$gTitle[app::get('b2c')->_('col:规格')]] );
            if( !$gData[0][$gTitle[app::get('b2c')->_('ibn:规格货号')]] )
                $gData[0][$gTitle[app::get('b2c')->_('ibn:规格货号')]] = $gData[0][$gTitle[app::get('b2c')->_('bn:商品编号')]];
            $proId = $oPro->dump( array('bn|tequal'=>$gData[0][$gTitle[app::get('b2c')->_('ibn:规格货号')]] ),'product_id,goods_id' );

            if($proId){
                if( ( !$rs['col:goods_id'] && $proId['product_id'] ) || ( $rs['col:goods_id'] && $rs['col:goods_id'] != $proId['goods_id'] ) ){
                    $msg = array( 'error'=>app::get('b2c')->_('规格货号:').$gData[0][$gTitle[app::get('b2c')->_('bn:商品编号')]].app::get('b2c')->_(' 已存在' ));
                    return false;
                }
            }

            $rs['product'][0] = $gData[0];
            if( $proId['product_id'] )
                $rs['product'][0]['col:product_id'] = $proId['product_id'];
        }else{

            reset($gData);
            $oSpec = &$this->app->model('specification');
            foreach( explode('|',$gData[0][$gTitle[app::get('b2c')->_('col:规格')]] ) as $speck => $specName ){
                $spec[$speck] = array(
                    'spec_name' => $specName,
                    'option' => array(),
                );
            }

            while( ( $aPro = next($gData) ) ){
                $aProk = key( $gData );
                $proId = $oPro->dump( array('bn|tequal'=>$aPro[$gTitle[app::get('b2c')->_('ibn:规格货号')]]),'product_id,goods_id' );

                if($proId){
                    if( ( !$rs['col:goods_id'] && $proId['product_id'] ) || ( $rs['col:goods_id'] && $rs['col:goods_id'] != $proId['goods_id'] ) ){
                        $msg = array( 'error'=>app::get('b2c')->_('规格货号:').$aPro[$gTitle[app::get('b2c')->_('ibn:规格货号')]].app::get('b2c')->_(' 已存在' ));
                        return false;
                    }
                }
                $aPro['col:product_id'] = $proId['product_id'];
                $rs['product'][$aProk] = $aPro;
                foreach( explode('|',$aPro[$gTitle[app::get('b2c')->_('col:规格')]]) as $specvk => $specv ){
                    $spec[$specvk]['option'][$specv] = $specv;
                }
            }
            foreach($spec as $sk => $aSpec){
                $specIdList = $oSpec->getSpecIdByAll($aSpec);
                foreach( $specIdList as $sv ){
                    if( array_key_exists($sv['spec_id'],(array)$goodsTmpl['gtype']['spec'] ) ){
                        $spec[$sk]['spec_id'] = $sv['spec_id'];
                    }
                }
                if( !$spec[$sk]['spec_id'] )
                    $spec[$sk]['spec_id'] = $specIdList[0]['spec_id'];
                if( !$spec[$sk]['spec_id'] ){
                    $msg = array('error'=>app::get('b2c')->_('规格：').$aSpec['spec_name'].app::get('b2c')->_('出现错误 请检查') );
                    return false;
                }
                $spec[$sk]['option'] = $oSpec->getSpecValuesByAll($spec[$sk]);
            }
            $pItem = 0;

            foreach( $rs['product'] as $prok => $prov ){

                if( !($pItem++) )$rs['product'][$prok]['col:default'] = 1;
                $proSpec = explode('|',$prov[$gTitle[app::get('b2c')->_('col:规格')]]);
                $rs['product'][$prok]['col:spec_info'] = implode(',',$proSpec);

                foreach( $proSpec as $aProSpeck => $aProSpec ){
                    //                    foreach( $spec as $aaSpec ){
                    $rs['product'][$prok]['col:spec_desc']['spec_value'][$spec[$aProSpeck]['spec_id']] = $spec[$aProSpeck]['option'][$aProSpec]['spec_value'];
                    $rs['product'][$prok]['col:spec_desc']['spec_private_value_id'][$spec[$aProSpeck]['spec_id']] = $spec[$aProSpeck]['option'][$aProSpec]['private_spec_value_id'];
                    $rs['product'][$prok]['col:spec_desc']['spec_value_id'][$spec[$aProSpeck]['spec_id']] = $spec[$aProSpeck]['option'][$aProSpec]['spec_value_id'];
                    //                    }
                }
            }

            unset( $rs[$gTitle[app::get('b2c')->_('col:规格')]] );
            foreach( $spec as $sk => $sv ){
                foreach( $sv['option'] as $psk => $psv ){
                    $rs[$gTitle[app::get('b2c')->_('col:规格')]][$sv['spec_id']]['option'][$psv['private_spec_value_id']] = $psv;
                }
            }
        }

        $return =  $this->model->ioSchema2sdf( $rs,$gTitle, $this->model->ioSchema['csv'] );
        if( $gData[0][$gTitle[app::get('b2c')->_('col:缩略图')]] ){
            $oImage = &app::get('image')->model('image');

            $image = explode('@',$gData[0][$gTitle[app::get('b2c')->_('col:缩略图')]] );
            if( count($image) == 2 ){
                $imageId = $image[0];
                $image = $image[1];
                $return['udfimg'] = 'true';
            }else{
                $imageId = null;
                $image = $image[0];
            }
            if( substr($image,0,4 ) == 'http' ){
                $imageName = null;
            }else{
                $imageName = null;
                $image = ROOT_DIR.'/'.$image;
            }
            if( $imageId && !$oImage->dump($imageId) )
                $imageId = null;
            $imageId = $oImage->store($image,$imageId,null,$imageName);

            $return['thumbnail_pic'] = $imageId;
        }

        if( $gData[0][$gTitle[app::get('b2c')->_('col:图片文件')]] ){
            $oImage = &app::get('image')->model('image');
            $i = 0;
            foreach( explode( '#', $gData[0][$gTitle[app::get('b2c')->_('col:图片文件')]] ) as $image ){
                $image = explode('@',$image);
                if( count($image) == 2 ){
                    $imageId = $image[0];
                    $image = $image[1];
                }else{
                    $imageId = null;
                    $image = $image[0];
                }
                if( substr($image,0,4 ) == 'http' ){
                    $imageName = null;
                }else{
                    $imageName = null;
                    $image = ROOT_DIR.'/'.$image;
                }
                if( $imageId && !$oImage->dump($imageId) )
                    $imageId = null;
                $imageId = $oImage->store($image,$imageId,null,$imageName);

                //商品批量上传图片大中小的处理
                $oImage->rebuild($imageId,array('L','M','S'));

                $return['images'][] = array(
                    'target_type'=>'goods',
                    'image_id'=>$imageId
                );
                if( $i++ == 0 ){
                    $return['image_default_id'] = $imageId;
                }

            }
        }

        if( trim( $gData[0][$gTitle[app::get('b2c')->_('keywords:商品关键字')]] ) ){
            $return['keywords'] = array();
            foreach( explode( '|', $gData[0][$gTitle[app::get('b2c')->_('keywords:商品关键字')]] ) as $kwk => $kwv ){
                $return['keywords'][] = array(
                    'keyword' => $kwv,
                    'res_type' => 'goods'
                );
            }
        }

        foreach( $rs['product'] as $prok => $prov ){
            if($prov[$gTitle[app::get('b2c')->_('col:上架')]] == 'N'){
                $return['product'][$prok-1]['status'] = 'false';
            }
            if($prov[$gTitle[app::get('b2c')->_('col:上架')]] == 'Y'){
                $return['product'][$prok-1]['status'] = 'true';
            }
        }
        foreach( $return['product'] as $pk => $pv ){
            $return['product'][$pk]['name'] = $return['name'];
            foreach( $pv['price']['member_lv_price'] as $lvk => $lvv ){
                if( $lvv['price'] === null || $lvv['price'] === '' ){
                    unset( $return['product'][$pk]['price']['member_lv_price'][$lvk] );
                    continue;
                }
                $return['product'][$pk]['price']['member_lv_price'][$lvk]['level_id'] = $lvk;
            }
        }

        $return['type']['type_id'] = intval( $goodsTmpl['gtype']['type_id'] );

        $this->io->goodsBn[$return['bn']] = null;

        return $return;

    }

    function prepared_import_row($row,$title,&$goodsTmpl,&$mark,&$newObjFlag,&$msg){
        if( substr($row[0],0,1) == '*' ){
            $mark = 'title';
            $newObjFlag = true;

            $oGType = &$this->app->model('goods_type');
            $goodsTmpl['gtype'] = $oGType->dump(array('name'=>ltrim($row[0],'*:')),'*',array(
                'brand' => array('*'),
                'spec' => array('*'),
                'props'=>array('*',array('props_value'=>array('*',null, array( 0,-1,'order_by ASC' ))) )) );
            if( !$goodsTmpl['gtype'] ){
                $msg = array('error'=>app::get('b2c')->_('商品类型:').ltrim( $row[0],'*:' ).app::get('b2c')->_(' 不存在'));
                return false;
            }

            if( $goodsTmpl['gtype']['props'] ){
                foreach( $goodsTmpl['gtype']['props'] as $propsk => $props ){
                    $this->model->ioSchema['csv']['props:'.$props['name']] = 'props/p_'.$propsk.'/value';
                    foreach( $props['options'] as $p => $v ){
                        $goodsTmpl['props_hash'][$props['name']][$v] = $p;
                    }
                }
            }

            if( $goodsTmpl['gtype']['params'] ){
                foreach( (array)$goodsTmpl['gtype']['params'] as $paramGroup => $paramItem ){
                    foreach( (array)$paramItem as $paramName => $paramValue ){
                        $this->model->ioSchema['csv']['params:'.$paramGroup.'->'.$paramName] = 'params/'.$paramGroup.'/'.$paramName;
                    }
                }
            }
            $oMlv = &$this->app->model('member_lv');
            foreach( $oMlv->getList('member_lv_id,name','',0,-1) as $mlv ){
                $this->model->ioSchema['csv']['price:'.$mlv['name']] = array('price/member_lv_price/'.$mlv['member_lv_id'].'/price','product');
            }


            return array_flip($row);
        }else{
            $mark = 'contents';

            if( $row[$title[app::get('b2c')->_('ibn:规格货号')]] ){
                if( $this->io->proBn && array_key_exists( $row[$title[app::get('b2c')->_('ibn:规格货号')]] , $this->io->proBn ) ){
                    $msg = array( 'error'=>app::get('b2c')->_('规格货号:').$row[$title[app::get('b2c')->_('ibn:规格货号')]].app::get('b2c')->_(' 文件中有重复') );
                    return false;
                }
                $this->io->proBn[$row[$title[app::get('b2c')->_('ibn:规格货号')]]] = null;
            }


            if( !$row[$title[app::get('b2c')->_('ibn:规格货号')]] || in_array($row[$title[app::get('b2c')->_('col:规格')]],array('','-')) ){
                $newObjFlag = true;
            }


            return $row;
        }
    }
}
