<?php
class importexport_importexport extends desktop_controller{
    public function __construct($app)
    {
        parent::__construct($app);
    }


    /*
     *  导出所支持的格式
     * */
    public function export_support_filetype(){
        $filetype = array(
            'csv'=>'.csv',
        );
        return $filetype;
    }

    /*
     * 导入支持的格式
     * */
    public function import_support_filetype(){
        $filetype = array(
            'csv'=>'.csv',
        );
        return $filetype;
    }

    /*
     * 检查导出,导入时，是否开启文件存储方式
     * */
    public function check_policy(){
        $ftp_server = app::get('importexport')->getConf('ftp_server_setting');
        if(!$ftp_server['policy'] || !$ftp_server['host']){
            return false;
            //trigger_error(app::get('importexport')->_('必须开启导入,导出文件存储方式,如：FTP'));
        }
        return true;
    }

    /*
     * 队列导出,导入，提供文件存储方式(默认提供ftp服务存储)
     * */
    public function queue_policy(){
        $ftp_server = app::get('importexport')->getConf('ftp_server_setting');
        return  $ftp_server['policy'];
    }

    public function gen_key($type='export'){
        $key = $type.'-'.time();
        return $key;
    }

    public function import_message($status=false,$msg){
        if($status){
            $status_msg =app::get('importexport')->_('上传成功');
        }else{
            $status_msg =app::get('importexport')->_('上传失败');
        }
        header("content-type:text/html; charset=utf-8");
        echo "<script>top.MessageBox.success(\"".$status_msg."\");alert(\"".$msg."\");if(parent.$('import_form').getParent('.dialog'))parent.$('import_form').getParent('.dialog').retrieve('instance').close();if(parent.window.finderGroup&&parent.window.finderGroup['".$_GET['finder_id']."'])parent.window.finderGroup['".$_GET['finder_id']."'].refresh();</script>";
        exit;
    }

    public function view_filter($filter,$params){
        $ctl_class = $filter['app'].'_ctl_'.$filter['ctl'];
        $mdl_class = $params['app'].'_mdl_'.$params['mdl'];
        $_POST['view'] = $filter['view'];
        $view_filter = $this->get_view_filter($ctl_class,$mdl_class);
        $filter = array_merge($filter,$view_filter);
        return $filter;
    }

    /*
     * 文件下载
     * */
    public function file_download(){
        $task_id = $_GET['task_id'];
        $params = app::get('importexport')->model('task')->getList('*',array('task_id'=>$task_id));
        $params = $params[0];
        if($params['status'] == '2' || $params['status'] =='6' ){
            $filename = $params['key'].'.'.$params['filetype'];
            $range = $this->set_queue_header($filename);
            $local_file = tempnam(TMP_DIR,'download');
            $ret = kernel::single('importexport_policy')->nb_get($local_file,$filename,$range);
            while ($ret == FTP_MOREDATA) {
                $fp=fopen($local_file,"rb");
                fseek($fp,$ftell);
                while(!feof($fp)){
                    set_time_limit(0);
                    print_r(fread($fp,1024*8));
                    $ftell = ftell($fp);
                    ob_flush();
                    flush();
                }
                fclose($fp);
                // 继续下载...
                $ret = kernel::single('importexport_policy')->nb_continue();
            }
        }
        exit;
    }

    public function set_queue_header($filename){
        header("Cache-Control: public");
        header("Content-Type: application/force-download");
        header("Accept-Ranges: bytes");
        if (strstr($_SERVER['HTTP_USER_AGENT'], "MSIE")) {
            $iefilename = preg_replace('/\./', '%2e', $filename, substr_count($filename, '.') - 1);
            header("Content-Disposition: attachment; filename=\"$iefilename\"");
        }else {
            header("Content-Disposition: attachment; filename=\"$filename\"");
        }

        $size = kernel::single('importexport_policy')->size($filename);
        if(isset($_SERVER['HTTP_RANGE'])) {
            error_log(var_export($_SERVER['HTTP_RANGE'],1)."\n",3,DATA_DIR."/log.log");
            list($a, $range)=explode("=",$_SERVER['HTTP_RANGE']);
            str_replace($range, "-", $range);
            $size2=$size-1;
            $new_length=$size2-$range;
            header("HTTP/1.1 206 Partial Content");
            header("Content-Length: $new_length");
            header("Content-Range: bytes $range$size2/$size");
        } else {
            $range = 0;
            $size2=$size-1;
            header("Content-Range: bytes 0-$size2/$size");
            header("Content-Length: ".$size);
        }
        return $range;
    }
}
